#ifndef RAQDATABLOCKHEADERV1_H
#define RAQDATABLOCKHEADERV1_H
#include "DAQDataFormats/RawDAQData.h"
#include "DAQDataFormats/Macros.h"
#include "DAQDataFormats/BitFields.h"
#include "DAQDataFormats/RawDataBlockHeaderV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlockHeader
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE datablockheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
          namespace CURRENT_FIELDS_SUB_NAMESPACE {
	    static const uint32_t SummaryBlock_Marker = 0xFABC;
          };

          namespace  VERSION_NAMESPACE {
          namespace CURRENT_FIELDS_SUB_NAMESPACE {
                static const uint32_t DATABLOCKHEADER_SIZE = 5;
          };

    class RawDataBlockHeader: public PREVIOUS_VERSION_CLASS_NAME {
        public:
            RawDataBlockHeader (const version_t); ///< The default constructor
            RawDataBlockHeader (const RawDataBlockHeader&);
            ~RawDataBlockHeader(); ///< Destructor

    protected:
	    INIT_FIRST(checkMarker          , const, bool, )
    };
  
  
}} // END NAMESPACE daqdataformats
#endif /* RAQDATABLOCKHEADERV0_H */
