#ifndef RAWSUMMARYDCMDATAHEADER_H
#define RAWSUMMARYDCMDATAHEADER_H
#include "DAQDataFormats/RawSummaryDCMDataHeaderV0.h"
#include "DAQDataFormats/Macros.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawSummaryDCMDataHeader
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE summarydcmdatahdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {
        static const version_t RAWSUMMARYDCMDATA_LATEST_VERSION = LAST_CLASS_VERSION;
    }

  class RawSummaryDCMDataHeader: public PREVIOUS_VERSION_CLASS_NAME {

        public:

            // Constructors
            RawSummaryDCMDataHeader(const version_t version = summarydcmdatahdr::RAWSUMMARYDCMDATA_LATEST_VERSION); //! The default constructor
            RawSummaryDCMDataHeader(const RawSummaryDCMDataHeader& copy_in); //! Deep copy constructor
            RawSummaryDCMDataHeader(const void*, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);      //! Shallow copy constructor
            /// Destructor
            ~RawSummaryDCMDataHeader();

            IMPLEMENT_MAIN_STANDARD
                    
            IMPLEMENT_GET_MAIN        (Version, uint32_t)
	    IMPLEMENT_GET_AND_SET_MAIN(NumEntries, uint32_t)

            IMPLEMENT_FUNCTION_RETURNING_FUNCTION_POINTER_0PAR(advanceNumEntries,      , bool)

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(CURRENT_CLASS)

        protected:
            IMPLEMENT_SET_MAIN(Version, uint32_t)

            bool             setFunctionPointers();

  };


} // END NAMESPCE daqdataformats
#endif /* RAWSUMMARYDCMDATAHEADER_H */
