#ifndef _DBUTILS_DAQCONFIG_ASICREGISTERVALUESET_H
#define _DBUTILS_DAQCONFIG_ASICREGISTERVALUESET_H

#include <stdint.h>

namespace dbutils {
namespace daqconfig {

/**
 * Simple container class for a set of ASIC register values.
 *
 * @author Kurt Biery
 * @version $Revision: 1.3 $ $Date: 2011/02/01 22:19:54 $
 */

class ASICRegisterValueSet {

 public:

    // ********************
    // *** Constructors ***
    // ********************

    ASICRegisterValueSet(int16_t spareValue, int16_t vtselValue,
                         int16_t refselValue, int16_t iselValue,
                         int16_t bwselValue, int16_t gselValue,
                         int16_t tfselValue, int16_t mux2to1Value,
                         int16_t mux8to1Value, int32_t qInjPixelMask);

    // *****************
    // *** Accessors ***
    // *****************

    int16_t getSpareValue() {return _spareValue;}
    int16_t getVtSelValue() {return _vtselValue;}
    int16_t getRefSelValue() {return _refselValue;}
    int16_t getISelValue() {return _iselValue;}
    int16_t getBWSelValue() {return _bwselValue;}
    int16_t getGSelValue() {return _gselValue;}
    int16_t getTfSelValue() {return _tfselValue;}
    int16_t getMux2to1Value() {return _mux2to1Value;}
    int16_t getMux8to1Value() {return _mux8to1Value;}
    int32_t getQInjPixelMask() {return _qInjPixelMask;}

    // *****************
    // *** Operators ***
    // *****************

    bool operator==(const ASICRegisterValueSet& other);
    bool operator!=(const ASICRegisterValueSet& other);

 private:

    int16_t _spareValue;
    int16_t _vtselValue;
    int16_t _refselValue;
    int16_t _iselValue;
    int16_t _bwselValue;
    int16_t _gselValue;
    int16_t _tfselValue;
    int16_t _mux2to1Value;
    int16_t _mux8to1Value;
    int32_t _qInjPixelMask;
};

};  // end of namespace daqconfig
};  // end of namespace dbutils

#endif
