#ifndef _NOVADAQ_HEXUTILS_H
#define _NOVADAQ_HEXUTILS_H

#include <string>
#include <stdint.h>

namespace novadaq {

/**
 * Utilities for parsing and formatting integers in hex.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/09/09 16:30:46 $
 */

namespace HexUtils
{

    std::string format(const int32_t& value, const int& ndigits = 8);
    std::string format(const int64_t& value, const int& ndigits = 16);
    std::string format(const std::string& decimalString,
                       const int& ndigits = 8);

    int64_t unsafeParse(const std::string& hexString);
    bool isValidHex(const std::string& hexString);

    bool parse(const std::string& hexString, int32_t& decimalValue);
    bool parse(const std::string& hexString, int64_t& decimalValue);

};  // end of namespace HexUtils

};  // end of namespace novadaq

#endif
