#include "DAQDataFormats/RawDataBlockHeaderV1.h"
#include <boost/format.hpp>

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlockHeader
#define  CURRENT_CLASS_VERSION        1
#define  CURRENT_FIELDS_SUB_NAMESPACE datablockheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats{
namespace VERSION_NAMESPACE{

//------------------------------------------------------------------------------
// Default constructor
RawDataBlockHeader::RawDataBlockHeader(const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
    ,ZEROOUT_FUNCTION(checkMarker)
{ }

//------------------------------------------------------------------------------
RawDataBlockHeader::RawDataBlockHeader(const RawDataBlockHeader& copyin):
     PREVIOUS_VERSION_CLASS_NAME(copyin)
    ,DEEPCOPY_FUNCTION(checkMarker)
{ }

//------------------------------------------------------------------------------
// Destructor
RawDataBlockHeader::~RawDataBlockHeader() { }

  bool RawDataBlockHeader::checkMarker()       const         { 
    return (EXECUTE_FUNCTION(getMarker)() == daqdataformats::datablockheader::DataBlock_Marker)
      || ((EXECUTE_FUNCTION(getMarker)() == daqdataformats::datablockheader::SummaryBlock_Marker) && EXECUTE_FUNCTION(getNumMicroBlocks)() <= 2);
}


}}// end of namespaces







      

