#include "DAQDataFormats/RawNanoSliceV4.h"
#include <boost/format.hpp>

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawNanoSlice
#define  CURRENT_CLASS_VERSION        4
#define  CURRENT_FIELDS_SUB_NAMESPACE rawnano
#include "DAQDataFormats/DataFormatLast.inc"
  
namespace daqdataformats{
namespace VERSION_NAMESPACE{
//------------------------Constructors------------------------------------------
RawNanoSlice::RawNanoSlice(const version_t version):
             PREVIOUS_VERSION_CLASS_NAME(version)
{ }
RawNanoSlice::RawNanoSlice(const NanoSlice& nano):
             PREVIOUS_VERSION_CLASS_NAME(nano)
{ }
//------------------------------------------------------------------------------
RawNanoSlice::RawNanoSlice (const RawNanoSlice& copyin):
             PREVIOUS_VERSION_CLASS_NAME(copyin)
{}

//------------------------Destructor--------------------------------------------
RawNanoSlice::~RawNanoSlice() { }


}}// end of namespaces
