///////////////////////////////////////////
// Define the High Res Time Stamp Counter
///////////////////////////////////////////

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include "DAQDataFormats/TimeStampCounter.h"

/*
 * High Resolution Time Stamp Counter 
 * Based on the intel cpu's clock 
 * register.  CPU must support the rtdsc
 * instruction
 */
// typedef unsigned long long cycles_t; /* Definte a data type to hold the register value */

/* Define the assembler instruction */
// #define rdtscll(val)				
// __asm__ __volatile__ ("rdtsc" : "=A" (val))

/* The function tsc will now return the value of the register properly */
// inline unsigned long long tsc(){
//  unsigned long long ret;
//  rdtscll(ret);
//  return ret;
// }

float CPUSpeed(){
  char buffer[1024];
  char* match;
  int bytes_read=0;
  float clock_speed;

  /* Read the /proc/cpuinfo area LINUX specific */
  FILE *fp=fopen("/proc/cpuinfo","r");
  bytes_read = fread(buffer,1,sizeof(buffer),fp);
  fclose(fp);

  match=strstr(buffer, "cpu MHz");
  if (match == NULL || bytes_read==0 ) {
    printf("Timer::Timer: Warning cpu clock speed not found\n");
    return -1;
  }
  sscanf(match, "cpu MHz : %f", &clock_speed);
  return clock_speed;
}

///////////////////////////////////////////
// END Def High Res Time Stamp Counter
///////////////////////////////////////////
