#include <DatabaseUtils/DAQConfig/ConfigDataSelector.h>

namespace dbutils {
namespace daqconfig {

/**
 *
 */
void ConfigDataSelector::
addSelectionColumn(std::string columnName)
{
    _selectionColumnList.push_back(columnName);
    _selectionValueFlagList.push_back(false);
    _selectionLowValueList.push_back("");
    _selectionHighValueList.push_back("");
}

/**
 *
 */
void ConfigDataSelector::
addSelectionColumn(std::string columnName,
                   std::string lowSelectionValue,
                   std::string highSelectionValue)
{
    _selectionColumnList.push_back(columnName);
    _selectionValueFlagList.push_back(true);
    _selectionLowValueList.push_back(lowSelectionValue);
    _selectionHighValueList.push_back(highSelectionValue);
}

/**
 *
 */
std::string ConfigDataSelector::
getSelectionColumn(uint32_t selectionIndex) const
{
    if (selectionIndex >= _selectionColumnList.size()) {
        return "";
    }
    return _selectionColumnList[selectionIndex];
}

/**
 *
 */
bool ConfigDataSelector::
hasSelectionValues(uint32_t selectionIndex) const
{
    if (selectionIndex >= _selectionValueFlagList.size()) {
        return false;
    }
    return _selectionValueFlagList[selectionIndex];
}

/**
 *
 */
std::string ConfigDataSelector::
getSelectionLowValue(uint32_t selectionIndex) const
{
    if (selectionIndex >= _selectionLowValueList.size()) {
        return "";
    }
    return _selectionLowValueList[selectionIndex];
}

/**
 *
 */
std::string ConfigDataSelector::
getSelectionHighValue(uint32_t selectionIndex) const
{
    if (selectionIndex >= _selectionHighValueList.size()) {
        return "";
    }
    return _selectionHighValueList[selectionIndex];
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
